=== debian/changelog ===
sumo (1.12.0+dfsg1-1) unstable; urgency=medium

  * [e174ad9] Fix typo
  * [0162713] New upstream version 1.12.0+dfsg1
  * [4554e20] Minor update of d-files
  * [ffcccc0] Set compat-level 13
  * [9dbf6ae] Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Anton Gladky <gladk@debian.org>  Fri, 11 Feb 2022 23:11:11 +0100
